package com.qunzhixinxi.hnqz.admin.api.dto;

import lombok.AccessLevel;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import java.util.Map;

/**
 * 任务相关DTO
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-11-05 18:12
 */
@NoArgsConstructor(access = AccessLevel.NONE)
public final class WmTaskDTO {

	@Data
	public static class OnOutPartyCreate {

		@NotBlank(message = "任务类型ID必填")
		private String taskTypeId;

		private String pkgName;

		private String pkgId;

		@NotBlank(message = "代表用户名必填")
		private String username;

		@NotEmpty(message = "三方结构必填")
		private Map<String, Object> struct;

		@NotEmpty(message = "三方结果必填")
		private Map<String, Object> result;

	}

}
