package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 部门管理
 * </p>
 *
 * @author hnqz
 * @since 2018-01-22
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class SysDept extends Model<SysDept> {

	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	@TableId
	private Integer deptId;
	/**
	 * 部门名称
	 */
	@NotBlank(message = "部门名称不能为空")
	private String name;

	/**
	 * 排序
	 */
	@NotNull(message = "排序值不能为空")
	private Integer sort;

	/**
	 * 服务起始时间
	 */
	private LocalDate issueDate;

	/**
	 * 服务截止时间
	 */
	private LocalDate expiryDate;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 修改时间
	 */
	private LocalDateTime updateTime;
	/**
	 *
	 */
	private Integer tenantId;
	/**
	 * 父级部门id
	 */
	private Integer parentId;

	/**
	 * 是否删除 1：已删除 0：正常
	 */
	@TableLogic
	private String delFlag;



	/**
	 *
	 */
	private String deptCode;
	/**
	 * 级别
	 */
	private Integer level;
	/**
	 * 药企名称
	 */
	private String level1Name;
	/**
	 * 药企ID
	 */
	private Integer level1Id;
	/**
	 * 一级代理商名称
	 */
	private String level2Name;
	/**
	 * 一级代理商ID
	 */
	private Integer level2Id;
	/**
	 * 二级代理商名称
	 */
	private String level3Name;
	/**
	 * 二级代理商ID
	 */
	private Integer level3Id;

	private String appId;
	private String appSecret;
	private String rsaPublicKey;
	private String queryUrl;
	private String subjectName;

	/**
	 * 税号
	 */
	private String taxCode;

	/**
	 * 结算主体类型：0->人力家，1->税邦云
	 */
	private String[] subjectType;

	/**
	 * 部门专用权限限制（字符串逗号分隔，0.导出）
	 */
	private String[] deptPermissions;

	@TableField(exist = false)
	private List<String> subList;

	/**
	 * gmv1收益率（万分之）
	 */
	private Integer gmv1Rate;

	/**
	 * gmv2收益率（万分之）
	 */
	private Integer gmv2Rate;

	/**
	 * 人力家服务费费率（万分之）
	 */
	private Integer renlijiaServiceChargeRate;

	/**
	 * 财务复核方式
	 */
	private UpmsType.FinancialReviewType financialReviewType;

}
