package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.qunzhixinxi.hnqz.admin.api.enums.SignatureStatusEnum;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 用户表
 * </p>
 *
 * @author hnqz
 * @since 2017-10-29
 */
@Data
public class SysUser implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * 主键ID
	 */
	@TableId(value = "user_id", type = IdType.AUTO)
	private Integer userId;

	/**
	 * 用户名
	 */
	private String username;

	/**
	 * 密码
	 */
	private String password;

	/**
	 * 身份证号
	 */
	private String idCardNumber;

	/**
	 * 签名
	 */
	private String userSign;

	/**
	 * 随机盐
	 */
	@JsonIgnore
	private String salt;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 修改时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 0-正常，1-删除
	 */
	@TableLogic
	private String delFlag;

	/**
	 * 锁定标记
	 */
	private String lockFlag;

	/**
	 * 手机号
	 */
	private String phone;

	/**
	 * 头像
	 */
	private String avatar;

	/**
	 * 部门ID
	 */
	private Integer deptId;

	/**
	 * 租户ID
	 */
	private Integer tenantId;

	/**
	 * 微信openid
	 */
	private String wxOpenid;

	/**
	 * 微信小程序openId
	 */
	private String miniOpenid;

	/**
	 * QQ openid
	 */
	private String qqOpenid;

	/**
	 * 码云唯一标识
	 */
	private String giteeLogin;

	/**
	 * 开源中国唯一标识
	 */
	private String oscId;

	/**
	 * 用户姓名
	 */
	private String realname;
	/**
	 * 省
	 */
	private String province;
	/**
	 * 省
	 */
	private String provinceCode;
	/**
	 * 市
	 */
	private String city;
	/**
	 * 市
	 */
	private String cityCode;
	/**
	 * 区
	 */
	private String area;
	/**
	 * 地址
	 */
	private String address;
	/**
	 * 备用字段1
	 */
	private String temp1;
	/**
	 * 备用字段2
	 */
	private String temp2;
	/**
	 * 备用字段3
	 */
	private String temp3;
	/**
	 * 备用字段4
	 */
	private String temp4;
	/**
	 * 物明经销商管理平台ID
	 */
	private String temp5;

	/**
	 * 物明经销商管理平台ID
	 */
	private String platId;

	/**
	 * 物明经销商管理平台ID
	 */
	private String drugEntId;

	/**
	 * 物明经销商管理平台ID
	 */
	private String w1;

	/**
	 * 税邦云认证状态
	 */
	private Integer certStatus;

	/**
	 * 人力家认证结果描述
	 */
	private String certRemark;

	/**
	 * 用户认证类型
	 * 0-人力家
	 * 1-税邦云
	 */
	private String userType;

	private String bankCardNumber;

	/**
	 * 银行预留手机号
	 */
	private String bankPhone;

	/**
	 * 开户行
	 */
	private String bankName;

	/**
	 * 人力家认证状态
	 */
	private Integer rljCertStatus;

	/**
	 * 税邦云协议签署,0->未签署，1->已签署
	 */
	private Integer taxHelperAgreementSignature;

	/**
	 * 小程序签署协议信息
	 */
	private String signAgreement;

	/**
	 * 是否提醒年龄超60周岁
	 */
	private Boolean ageReminder;

}
