package com.qunzhixinxi.hnqz.admin.api.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.qunzhixinxi.hnqz.admin.api.entity.SysRole;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPlatformQuizTestResult;
import com.qunzhixinxi.hnqz.admin.api.model.WmQuizResultModel;
import com.qunzhixinxi.hnqz.common.core.sensitive.Sensitive;
import com.qunzhixinxi.hnqz.common.core.sensitive.SensitiveTypeEnum;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * @author hnqz
 * @date 2017/10/29
 */
@Data
public class UserVO implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * 主键ID
	 */
	private Integer userId;

	/**
	 * 用户名
	 */
	private String username;

	/**
	 * 身份证号
	 */
	private String idCardNumber;

	/**
	 * 密码
	 */
	private String password;

	/**
	 * 随机盐
	 */
	private String salt;

	/**
	 * 微信openid
	 */
	private String wxOpenid;

	/**
	 * QQ openid
	 */
	private String qqOpenid;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 修改时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 0-正常，1-删除
	 */
	private String delFlag;

	/**
	 * 锁定标记
	 */
	private String lockFlag;

	/**
	 * 手机号
	 */
	@Sensitive(type = SensitiveTypeEnum.MOBILE_PHONE)
	private String phone;

	/**
	 * 头像
	 */
	private String avatar;

	/**
	 * 部门ID
	 */
	private Integer deptId;

	/**
	 * 租户ID
	 */
	private Integer tenantId;

	/**
	 * 部门名称
	 */
	private String deptName;


	/**
	 * 用户姓名
	 */
	private String realname;
	/**
	 * 省
	 */
	private String province;
	private String provinceCode;
	/**
	 * 市
	 */
	private String city;
	private String cityCode;
	/**
	 * 区
	 */
	private String area;
	/**
	 * 地址
	 */
	private String address;
	/**
	 * 备用字段1
	 */
	private String temp1;
	/**
	 * 备用字段2
	 */
	private String temp2;
	/**
	 * 备用字段3
	 */
	private String temp3;
	/**
	 * 备用字段4
	 */
	private String temp4;
	/**
	 * 备用字段5
	 */
	private String temp5;

	/**
	 * 备用字段5
	 */
	private String platId;


	/**
	 * 备用字段5
	 */
	private String drugEntId;

	/**
	 * 角色列表
	 */
	private List<SysRole> roleList;

	/**
	 * 备用字段5
	 */
	private String w1;

	/**
	 * 人力家认证状态
	 */
	private Integer certStatus;

	private String certRemark;

	private String userSign;

	private String userType;

	private String bankCardNumber;

	/**
	 * 银行预留手机号
	 */
	private String bankPhone;

	/**
	 * 开户行
	 */
	private String bankName;

	/**
	 * 人力家认证状态
	 */
	private Integer rljCertStatus;

	/**
	 * 税邦云协议签署,0->未签署，1->已签署 2-> 需补签
	 */
	private Integer taxHelperAgreementSignature;

	/**
	 * 结算主体和通道
	 */
	private Map<String, Integer> subjectTypeAndChannel;

	/**
	 * 不同渠道的认证状态
	 */
	private String[] certStatusArr;

	/**
	 * 不同渠道认证信息列表 ?为SysUserSubVO对象
	 */
	private List<?> certList;

	/**
	 * 小程序签署协议信息
	 */
	private String signAgreement;

	/**
	 * 是否提醒年龄超60周岁
	 */
	private Boolean ageReminder;


	@TableField(exist = false)
	private List<WmQuizResultModel> quizResult;

}
