package com.qunzhixinxi.hnqz.admin.controller;

import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.service.WmBizReminderService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 业务未读提醒控制层
 *
 * @author lixuesong
 * @date 2023/10/25
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("/biz-reminder")
public class WmBizReminderController {

	private final WmBizReminderService wmBizReminderService;

	/**
	 * 获取标记状态(TRUE-已读, FALSE-未读)
	 *
	 * @param bizReminderType 提醒类型
	 * @return {@link Boolean} 是否已读
	 */
	@GetMapping("/read-status")
	R<Boolean> getReminder(@RequestParam("bizReminderType") UpmsType.BizReminderType bizReminderType) {
		return R.ok(wmBizReminderService.getReadStatus(bizReminderType));
	}
}
