package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmCro;
import com.qunzhixinxi.hnqz.admin.service.WmCroService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;


/**
 * CRO管理
 *
 * @author Dhy
 * @date 2020-12-17 14:37:09
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmcro" )
public class WmCroController {

    private final WmCroService wmCroService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmCro CRO
     * @return
     */
    @GetMapping("/page" )
    public R getWmCroPage(Page page, WmCro wmCro) {
        return R.ok(wmCroService.selectCroList(page, wmCro));
    }


    /**
     * 通过id查询CRO
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmCroService.getById(id));
    }

    /**
     * 新增CRO
     * @param wmCro CRO
     * @return R
     */
    @SysLog("新增CRO管理" )
    @PostMapping
    public R save(@RequestBody WmCro wmCro) {
		wmCro.setUpdateTime(LocalDateTime.now());
		return R.ok(wmCroService.save(wmCro));
    }

    /**
     * 修改CRO
     * @param wmCro CRO
     * @return R
     */
    @SysLog("修改CRO管理" )
    @PutMapping
    public R updateById(@RequestBody WmCro wmCro) {
    	wmCro.setUpdateTime(LocalDateTime.now());
        return R.ok(wmCroService.updateById(wmCro));
    }

    /**
     * 通过id删除CRO
     * @param id id
     * @return R
     */
    @SysLog("通过id删除CRO" )
    @DeleteMapping("/{id}" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmCroService.removeById(id));
    }

}
