package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmDaProject;
import com.qunzhixinxi.hnqz.admin.service.WmDaProjectService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

/**
 * 档案-项目管理
 *
 * @author Liujh
 * @date 2020-12-8
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmdaproject")
public class WmDaProjectController {
	private final WmDaProjectService wmDaProjectService;

	/**
	 * 查看项目管理信息
	 */
	@PostMapping("/selectProjects")
	public R selectProjects(@RequestBody WmDaProject wmDaProject) {
		try {
			return R.ok(wmDaProjectService.selectProjects(wmDaProject));
		} catch (Exception e) {
			e.printStackTrace();
			return R.failed();
		}
	}

	/**
	 * 分页查询项目管理信息
	 */
	@GetMapping("/selectWmDaProjectList")
	public R selectWmDaProjectList(Page page, WmDaProject wmDaProject) {
		try {
			return R.ok(wmDaProjectService.selectWmDaProjectList(page, wmDaProject));
		} catch (Exception e) {
			e.printStackTrace();
			return R.failed();
		}
	}

	/**
	 * 编辑项目管理信息
	 */
	@SysLog("修改档案-项目管理")
	@PostMapping("updateWmDaProjectsById")
	public R updateWmDaProjectsById(@RequestBody WmDaProject wmDaProject) {
		Integer currentUserId = SecurityUtils.getUser().getId();//当前用户id
		return wmDaProjectService.updateWmDaProjectsById(wmDaProject,currentUserId);
	}

	/**
	 * 新增项目管理信息
	 */
	@SysLog("新增档案-项目管理")
	@PostMapping("insertWmDaProjects")
	public R<WmDaProject> insertWmDaProjects(@RequestBody WmDaProject wmDaProject) {
		Integer currentUserId = SecurityUtils.getUser().getId();//当前用户id
		return wmDaProjectService.insertWmDaProjects(wmDaProject, currentUserId);
	}
}
