package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.admin.entity.WmDeptBudget;
import com.qunzhixinxi.hnqz.admin.service.WmDeptBudgetService;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import org.springframework.security.access.prepost.PreAuthorize;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;


/**
 *
 *
 * @author xyz
 * @date 2021-04-26 18:05:10
 */
@RestController
@AllArgsConstructor
@RequestMapping("/budget" )
public class WmDeptBudgetController {

    private final  WmDeptBudgetService wmDeptBudgetService;

	/**
	 * 分页查询
	 * @param page 分页对象
	 * @param wmDeptBudget
	 * @return
	 */
	@GetMapping("/getBudgetViewPage" )
	public R getBudgetViewPage(Page page, WmDeptBudget wmDeptBudget) {
		wmDeptBudget.setDeptId(SecurityUtils.getUser().getDeptId());
		return R.ok(wmDeptBudgetService.getBudgetViewPage(page, wmDeptBudget));
	}

	/**
	 * 分页查询
	 * @param page 分页对象
	 * @param wmDeptBudget
	 * @return
	 */
	@GetMapping("/getBudgetEntViewPage" )
	public R getBudgetEntViewPage(Page page, WmDeptBudget wmDeptBudget) {
		wmDeptBudget.setDeclareDept(SecurityUtils.getUser().getDeptId());
		return R.ok(wmDeptBudgetService.getBudgetEntViewPage(page, wmDeptBudget));
	}


    /**
     * 分页查询
     * @param page 分页对象
     * @param wmDeptBudget
     * @return
     */
    @GetMapping("/page" )
    public R getWmDeptBudgetPage(Page page, WmDeptBudget wmDeptBudget) {
        return R.ok(wmDeptBudgetService.page(page, Wrappers.query(wmDeptBudget)));
    }


    /**
     * 通过id查询
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmDeptBudgetService.getById(id));
    }

    /**
     * 新增
     * @param wmDeptBudget
     * @return R
     */
    @SysLog("新增" )
    @PostMapping
    public R save(@RequestBody WmDeptBudget wmDeptBudget) {
		wmDeptBudget.setDeptId(SecurityUtils.getUser().getDeptId());
		wmDeptBudget.setCreateTime(LocalDateTime.now());
        return R.ok(wmDeptBudgetService.save(wmDeptBudget));
    }

    /**
     * 修改
     * @param wmDeptBudget
     * @return R
     */
    @SysLog("修改" )
    @PutMapping
    public R updateById(@RequestBody WmDeptBudget wmDeptBudget) {
        return R.ok(wmDeptBudgetService.updateById(wmDeptBudget));
    }

    /**
     * 通过id删除
     * @param id id
     * @return R
     */
    @SysLog("通过id删除" )
    @DeleteMapping("/{id}" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmDeptBudgetService.removeById(id));
    }

}
