package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmRelation;
import com.qunzhixinxi.hnqz.admin.service.WmRelationService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;


/**
 * CSO关系表
 *
 * @author pigx code generator
 * @date 2021-01-05 14:49:04
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmrelation" )
public class WmRelationController {

    private final WmRelationService wmRelationService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmRelation CSO关系表
     * @return
     */
    @GetMapping("/page" )
    public R getWmRelationPage(Page page, WmRelation wmRelation) {
        return R.ok(wmRelationService.page(page, Wrappers.query(wmRelation)));
    }


    /**
     * 通过id查询CSO关系表
     * @param upId id
     * @return R
     */
    @GetMapping("/{upId}" )
    public R getById(@PathVariable("upId" ) Integer upId) {
        return R.ok(wmRelationService.getById(upId));
    }

    /**
     * 新增CSO关系表
     * @param wmRelation CSO关系表
     * @return R
     */
    @SysLog("新增CSO关系表" )
    @PostMapping
    public R save(@RequestBody WmRelation wmRelation) {
        return R.ok(wmRelationService.save(wmRelation));
    }

    /**
     * 修改CSO关系表
     * @param wmRelation CSO关系表
     * @return R
     */
    @SysLog("修改CSO关系表" )
    @PutMapping
    public R updateById(@RequestBody WmRelation wmRelation) {
        return R.ok(wmRelationService.updateById(wmRelation));
    }

    /**
     * 通过id删除CSO关系表
     * @param upId id
     * @return R
     */
    @SysLog("通过id删除CSO关系表" )
    @DeleteMapping("/{upId}" )
    public R removeById(@PathVariable Integer upId) {
        return R.ok(wmRelationService.removeById(upId));
    }

}
