package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageTaskRef;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageTaskRefService;
import org.springframework.security.access.prepost.PreAuthorize;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;


/**
 * 任务-积分包关联
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmscorepackagetaskref" )
public class WmScorePackageTaskRefController {

    private final  WmScorePackageTaskRefService wmScorePackageTaskRefService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmScorePackageTaskRef 任务-积分包关联
     * @return
     */
    @GetMapping("/page" )
    public R getWmScorePackageTaskRefPage(Page page, WmScorePackageTaskRef wmScorePackageTaskRef) {
		OrderItem orderItem=new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);

        return R.ok(wmScorePackageTaskRefService.page(page, Wrappers.query(wmScorePackageTaskRef)));
    }


    /**
     * 通过id查询任务-积分包关联
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmScorePackageTaskRefService.getById(id));
    }

    /**
     * 新增任务-积分包关联
     * @param wmScorePackageTaskRef 任务-积分包关联
     * @return R
     */
    @SysLog("新增任务-积分包关联" )
    @PostMapping
    public R save(@RequestBody WmScorePackageTaskRef wmScorePackageTaskRef) {
		wmScorePackageTaskRef.setCreateTime(LocalDateTime.now());
        return R.ok(wmScorePackageTaskRefService.save(wmScorePackageTaskRef));
    }

    /**
     * 修改任务-积分包关联
     * @param wmScorePackageTaskRef 任务-积分包关联
     * @return R
     */
    @SysLog("修改任务-积分包关联" )
    @PutMapping
    public R updateById(@RequestBody WmScorePackageTaskRef wmScorePackageTaskRef) {
        return R.ok(wmScorePackageTaskRefService.updateById(wmScorePackageTaskRef));
    }

    /**
     * 通过id删除任务-积分包关联
     * @param id id
     * @return R
     */
    @SysLog("通过id删除任务-积分包关联" )
    @DeleteMapping("/{id}" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmScorePackageTaskRefService.removeById(id));
    }

}
