package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.admin.entity.WmSettleAccountReceive;
import com.qunzhixinxi.hnqz.admin.service.WmSettleAccountReceiveService;
import org.springframework.security.access.prepost.PreAuthorize;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;


/**
 *
 *
 * @author zhangwt
 * @date 2021-02-01 18:06:37
 */
@RestController
@AllArgsConstructor
@RequestMapping("/accountReceive" )
public class WmSettleAccountReceiveController {

    private final  WmSettleAccountReceiveService wmSettleAccountReceiveService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmSettleAccountReceive
     * @return
     */
    @GetMapping("/page" )
    public R getWmSettleAccountReceivePage(Page page, WmSettleAccountReceive wmSettleAccountReceive) {
        return R.ok(wmSettleAccountReceiveService.page(page, Wrappers.query(wmSettleAccountReceive)));
    }


    /**
     * 通过id查询
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmSettleAccountReceiveService.getById(id));
    }

    /**
     * 新增
     * @param wmSettleAccountReceive
     * @return R
     */
    @SysLog("新增" )
    @PostMapping
    public R save(@RequestBody WmSettleAccountReceive wmSettleAccountReceive) {
        return R.ok(wmSettleAccountReceiveService.save(wmSettleAccountReceive));
    }

    /**
     * 修改
     * @param wmSettleAccountReceive
     * @return R
     */
    @SysLog("修改" )
    @PutMapping
    public R updateById(@RequestBody WmSettleAccountReceive wmSettleAccountReceive) {
        return R.ok(wmSettleAccountReceiveService.updateById(wmSettleAccountReceive));
    }

    /**
     * 通过id删除
     * @param id id
     * @return R
     */
    @SysLog("通过id删除" )
    @DeleteMapping("/{id}" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmSettleAccountReceiveService.removeById(id));
    }

}
