package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskContent;
import com.qunzhixinxi.hnqz.admin.service.WmTaskContentService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;


/**
 * 任务内容表
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmtaskcontent" )
public class WmTaskContentController {

    private final  WmTaskContentService wmTaskContentService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmTaskContent 任务内容表
     * @return
     */
    @GetMapping("/page" )
	//@PreAuthorize("@pms.hasPermission('admin_wmtaskcontent_view')" )
    public R getWmTaskContentPage(Page page, WmTaskContent wmTaskContent) {
//		OrderItem orderItem=new OrderItem();
//		orderItem.setColumn("create_time");
//		orderItem.setAsc(false);
//		page.addOrder(orderItem);

        return R.ok(wmTaskContentService.page(page, Wrappers.query(wmTaskContent)));
    }


    /**
     * 通过id查询任务内容表
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
	//@PreAuthorize("@pms.hasPermission('admin_wmtaskcontent_view')" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmTaskContentService.getById(id));
    }

    /**
     * 新增任务内容表
     * @param wmTaskContent 任务内容表
     * @return R
     */
    @SysLog("新增任务内容表" )
    @PostMapping
	//@PreAuthorize("@pms.hasPermission('admin_wmtaskcontent_add')" )
    public R save(@RequestBody WmTaskContent wmTaskContent) {
    	return R.ok(wmTaskContentService.save(wmTaskContent));
    }

    /**
     * 修改任务内容表
     * @param wmTaskContent 任务内容表
     * @return R
     */
    @SysLog("修改任务内容表" )
    @PutMapping
	//@PreAuthorize("@pms.hasPermission('admin_wmtaskcontent_edit')" )
    public R updateById(@RequestBody WmTaskContent wmTaskContent) {
        return R.ok(wmTaskContentService.updateById(wmTaskContent));
    }

    /**
     * 通过id删除任务内容表
     * @param id id
     * @return R
     */
    @SysLog("通过id删除任务内容表" )
    @DeleteMapping("/{id}" )
	//@PreAuthorize("@pms.hasPermission('admin_wmtaskcontent_del')" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmTaskContentService.removeById(id));
    }

	/**
	 * 获取药企列表
	 * @return 角色列表
	 */
	@GetMapping("/list")
	public R listWmScorePackage() {
		WmTaskContent wmDaDrugEnt=new WmTaskContent();
		return R.ok(wmTaskContentService.list(Wrappers.query(wmDaDrugEnt)));
	}

}
