package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskSettleNote;
import com.qunzhixinxi.hnqz.admin.service.WmTaskSettleNoteService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.bind.annotation.*;

/**
 * 弃用
 * @Modify: start
 * @Version: v2021.4.16
 * @Author: ryz
 * @Date: 2021/4/26
*/
@RestController
@AllArgsConstructor
@RequestMapping("/taskSettle" )
public class WmTaskSettleNoteController {

    private final  WmTaskSettleNoteService wmTaskSettleNoteService;

	/**
	 * 分页查询任务+结算信息
	 * @param page 分页对象
	 * @param wmTaskSettleNote
	 * @return
	 */
	@GetMapping("/info/page" )
	public R getWmTaskSettleInfoPage(Page page, WmTaskSettleNote wmTaskSettleNote) {
		if(StringUtils.isEmpty(wmTaskSettleNote.getPackageId()) || StringUtils.isEmpty(wmTaskSettleNote.getUserId())){

			return R.failed("参数异常");
		}

		return R.ok(wmTaskSettleNoteService.getWmTaskSettleInfoPage(page, wmTaskSettleNote));
	}

	/**
	 * 分页查询任务+结算信息
	 * @param page 分页对象
	 * @param wmTaskSettleNote
	 * @return
	 */
	@GetMapping("/settle/page" )
	public R getWmTaskForSettlePage(Page page, WmTaskSettleNote wmTaskSettleNote) {
		if(StringUtils.isEmpty(wmTaskSettleNote.getPackageId())){
			return R.failed("参数异常");
		}

		return R.ok(wmTaskSettleNoteService.getWmTaskForSettlePage(page, wmTaskSettleNote));
	}

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmTaskSettleNote
     * @return
     */
    @GetMapping("/page" )
    public R getWmTaskSettleNotePage(Page page, WmTaskSettleNote wmTaskSettleNote) {
        return R.ok(wmTaskSettleNoteService.page(page, Wrappers.query(wmTaskSettleNote)));
    }

	/**
	 * 查询生成结算信息
	 * @param wmTaskSettleNote
	 * @return R
	 */
	@PostMapping("/getSettleInfo" )
	public R getSettleInfo(@RequestBody WmTaskSettleNote wmTaskSettleNote) {
		return wmTaskSettleNoteService.getSettleInfo(wmTaskSettleNote);
	}

	/**
	 * 保存
	 * @param note
	 * @return R
	 */
	@PostMapping("/saveSettleInfo" )
	public R saveSettleInfo(@RequestBody WmTaskSettleNote note) {
//		if(null == note.getId()){
//			return R.failed("参数异常");
//		}
		return wmTaskSettleNoteService.saveSettleInfo(note);
	}

	/**
	 * 提交结算申请
	 * @param note
	 * @return R
	 */
	@PostMapping("/subSettleInfo" )
	public R subSettleInfo(@RequestBody WmTaskSettleNote note) {
//		if(null == note.getId()){
//			return R.failed("参数异常");
//		}
		return wmTaskSettleNoteService.subSettleInfo(note);
	}

	/**
	 * 撤销结算申请
	 * @param note
	 * @return R
	 */
	@PostMapping("/revokeSettle" )
	public R revokeSettle(@RequestBody WmTaskSettleNote note) {
//		if(null == note.getId()){
//			return R.failed("参数异常");
//		}
		return wmTaskSettleNoteService.revokeSettle(note);
	}

	/**
	 * 提交结算申请
	 * @param note
	 * @return R
	 */
	@PostMapping("/singletSettle" )
	public R singletSettle(@RequestBody WmTaskSettleNote note) {
		if(null == note.getId()){
			return R.failed("参数异常");
		}
		return wmTaskSettleNoteService.singletSettle(note);
	}

	/**
	 * 提交结算申请
	 * @param note
	 * @return R
	 */
	@PostMapping("/batchSettle" )
	public R batchSettle(@RequestBody WmTaskSettleNote note) {
		if(StringUtils.isEmpty(note.getIdStr())){
			return R.failed("参数异常");
		}
		return wmTaskSettleNoteService.batchSettle(note);
	}


    /**
     * 通过id查询
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmTaskSettleNoteService.getById(id));
    }

    /**
     * 新增
     * @param wmTaskSettleNote
     * @return R
     */
    @SysLog("新增" )
    @PostMapping
    public R save(@RequestBody WmTaskSettleNote wmTaskSettleNote) {
        return R.ok(wmTaskSettleNoteService.save(wmTaskSettleNote));
    }

    /**
     * 修改
     * @param wmTaskSettleNote
     * @return R
     */
    @SysLog("修改" )
    @PutMapping
    public R updateById(@RequestBody WmTaskSettleNote wmTaskSettleNote) {
        return R.ok(wmTaskSettleNoteService.updateById(wmTaskSettleNote));
    }

    /**
     * 通过id删除
     * @param id id
     * @return R
     */
    @SysLog("通过id删除" )
    @DeleteMapping("/{id}" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmTaskSettleNoteService.removeById(id));
    }

}
