package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskTypeScoreRef;
import com.qunzhixinxi.hnqz.admin.service.WmTaskTypeScoreRefService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;


/**
 * 任务类型打分
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmtasktypescoreref" )
public class WmTaskTypeScoreRefController {

    private final  WmTaskTypeScoreRefService wmTaskTypeScoreRefService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmTaskTypeScoreRef 任务类型打分
     * @return
     */
    @GetMapping("/page" )
	//@PreAuthorize("@pms.hasPermission('admin_wmtasktypescoreref_view')" )
    public R getWmTaskTypeScoreRefPage(Page page, WmTaskTypeScoreRef wmTaskTypeScoreRef) {

		OrderItem orderItem=new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);

        return R.ok(wmTaskTypeScoreRefService.page(page, Wrappers.query(wmTaskTypeScoreRef)));
    }


    /**
     * 通过id查询任务类型打分
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
	//@PreAuthorize("@pms.hasPermission('admin_wmtasktypescoreref_view')" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmTaskTypeScoreRefService.getById(id));
    }

    /**
     * 新增任务类型打分
     * @param wmTaskTypeScoreRef 任务类型打分
     * @return R
     */
    @SysLog("新增任务类型打分" )
    @PostMapping
	//@PreAuthorize("@pms.hasPermission('admin_wmtasktypescoreref_add')" )
    public R save(@RequestBody WmTaskTypeScoreRef wmTaskTypeScoreRef) {
		wmTaskTypeScoreRef.setCreateTime(LocalDateTime.now());
        return R.ok(wmTaskTypeScoreRefService.save(wmTaskTypeScoreRef));
    }

    /**
     * 修改任务类型打分
     * @param wmTaskTypeScoreRef 任务类型打分
     * @return R
     */
    @SysLog("修改任务类型打分" )
    @PutMapping
	//@PreAuthorize("@pms.hasPermission('admin_wmtasktypescoreref_edit')" )
    public R updateById(@RequestBody WmTaskTypeScoreRef wmTaskTypeScoreRef) {
        return R.ok(wmTaskTypeScoreRefService.updateById(wmTaskTypeScoreRef));
    }

    /**
     * 通过id删除任务类型打分
     * @param id id
     * @return R
     */
    @SysLog("通过id删除任务类型打分" )
    @DeleteMapping("/{id}" )
	//@PreAuthorize("@pms.hasPermission('admin_wmtasktypescoreref_del')" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmTaskTypeScoreRefService.removeById(id));
    }

}
