package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.admin.entity.WmWkArticleShare;
import com.qunzhixinxi.hnqz.admin.service.WmWkArticleShareService;
import org.springframework.security.access.prepost.PreAuthorize;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;


/**
 * 文章分享
 *
 * @author pigx code generator
 * @date 2020-07-09 22:34:30
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmwkarticleshare" )
public class WmWkArticleShareController {

    private final  WmWkArticleShareService wmWkArticleShareService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmWkArticleShare 文章分享
     * @return
     */
    @GetMapping("/page" )
    @PreAuthorize("@pms.hasPermission('admin_wmwkarticleshare_view')" )
    public R getWmWkArticleSharePage(Page page, WmWkArticleShare wmWkArticleShare) {

		OrderItem orderItem=new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);

        return R.ok(wmWkArticleShareService.page(page, Wrappers.query(wmWkArticleShare)));
    }


    /**
     * 通过id查询文章分享
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    @PreAuthorize("@pms.hasPermission('admin_wmwkarticleshare_view')" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmWkArticleShareService.getById(id));
    }

    /**
     * 新增文章分享
     * @param wmWkArticleShare 文章分享
     * @return R
     */
    @SysLog("新增文章分享" )
    @PostMapping
    @PreAuthorize("@pms.hasPermission('admin_wmwkarticleshare_add')" )
    public R save(@RequestBody WmWkArticleShare wmWkArticleShare) {
		wmWkArticleShare.setCreateTime(LocalDateTime.now());
        return R.ok(wmWkArticleShareService.save(wmWkArticleShare));
    }

    /**
     * 修改文章分享
     * @param wmWkArticleShare 文章分享
     * @return R
     */
    @SysLog("修改文章分享" )
    @PutMapping
    @PreAuthorize("@pms.hasPermission('admin_wmwkarticleshare_edit')" )
    public R updateById(@RequestBody WmWkArticleShare wmWkArticleShare) {
        return R.ok(wmWkArticleShareService.updateById(wmWkArticleShare));
    }

    /**
     * 通过id删除文章分享
     * @param id id
     * @return R
     */
    @SysLog("通过id删除文章分享" )
    @DeleteMapping("/{id}" )
    @PreAuthorize("@pms.hasPermission('admin_wmwkarticleshare_del')" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmWkArticleShareService.removeById(id));
    }

}
