package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Map;

/**
 * 部门管理
 *
 * @author ryz
 * @date 2021-04-19 16:02:30
 */
@Data
@TableName(value = "sys_dept_sub", autoResultMap = true)
@EqualsAndHashCode(callSuper = true)
public class SysDeptSub extends Model<SysDeptSub> {

	private static final long serialVersionUID = -1765712668252192954L;

	@TableId
	private Integer subId;

	private Integer deptId;

	private String appId;

	private String appSecret;

	private String rsaPublicKey;

	private String queryUrl;

	private String subjectName;

	private String subjectType;

	private Integer subjectChannel;

	/**
	 * 税源地
	 */
	private SubjectLocation subjectLocation;

	private BigDecimal limitAmount;

	private String enableFlag;

	private String subjectUserType;

	private String subjectInvoiceCategory;

	private LocalDateTime updateTime;

	private BigDecimal serviceCharge;

	/**
	 * 批次付款渠道编号
	 */
	private String[] pathNo;

	/**
	 * 认证是否启用：1：启用，0：停用
	 */
	private Boolean certEnable;

	/**
	 * 结算是否启用：1：启用，0：停用
	 */
	private Boolean settleEnable;

	/**
	 * E证通认证是否启用：1-启用，0-停用
	 */
	private Boolean eidEnable;


}
