package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;
import java.util.Map;

/**
 * 档案-药企
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_drug_ent")
@EqualsAndHashCode(callSuper = true)
public class WmDaDrugEnt extends Model<WmDaDrugEnt> {
	private static final long serialVersionUID = 1L;

	@TableId
	private String id;
	/**
	 * 企业名称
	 */
	private String entname;
	/**
	 * 统一社会信用代码
	 */
	private String entcode;

	private String temp1;

	private String temp2;

	private String temp3;

	private String temp4;
	/**
	 * 组织机构ID
	 */
	private String deptId;
	/**
	 * 是否删除
	 */
	private String delFlag;
	/**
	 * 是否禁用
	 */
	private String enableFlag;
	/**
	 * 所属租户
	 */
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	private Integer createUser;
	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	private Integer updateUser;

	private String pgqx;

	/**
	 * 管理模式
	 */
	private String management;

	/**
	 * 结算主体类型：0->人力家，1->税邦云
	 */
	private String[] subjectType;

	/**
	 * 结算主体和通道
	 */
	@TableField(exist = false)
	private Map<String, Integer> subjectTypeAndChannel;

	/**
	 * 部门专用权限限制（0.导出）
	 */
	@TableField(exist = false)
	private String[] deptPermissions;

	/**
	 * 财务复核方式(字段存于sys_dept表)
	 */
	@TableField(exist = false)
	private UpmsType.FinancialReviewType financialReviewType;

}
