
package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 档案-药企药品
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_drug_ent_drugtable")
@EqualsAndHashCode(callSuper = true)
public class WmDaDrugEntDrugtable extends Model<WmDaDrugEntDrugtable> {
	private static final long serialVersionUID = 1L;


	@TableId
	private String id;
	/**
	 * 药品名称
	 */
	private String drugname;
	/**
	 * 通用药品你名称
	 */
	private String drugnameTy;
	/**
	 * 企业ID
	 */
	private String drugEntId;
	/**
	 * 是否医保
	 */
	private String isYb;
	/**
	 * 剂型ID
	 */
	private String doseId;
	/**
	 * 规格ID
	 */
	private String guigeId;
	/**
	 * 备注
	 */
	private String remark;
	/**
	 * 组织机构ID
	 */
	private Integer deptId;
	/**
	 * 是否删除
	 */
	private String delFlag;
	/**
	 * 是否禁用
	 */
	private String enableFlag;
	/**
	 * 所属租户
	 */
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	private Integer createUser;
	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	private Integer updateUser;

	private String drugEntName;

	private String ssxkcyy;

	/**
	 * 0-原研  1-仿制
	 */
	private String yyfz;

	private Integer drugEntNum;

	/**
	 * 分配的推广企业
	 */
	@TableField(exist = false)
	private List<String> reDeptList;

	/**
	 * 剂型名称
	 */
	private String doseName;

	/**
	 * 规格名称
	 */
	private String guigeName;
}
