package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.time.LocalDateTime;

/**
 * 档案-医院
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_hospital")
@EqualsAndHashCode(callSuper = true)
public class WmDaHospital extends Model<WmDaHospital> {
private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId
    private String id;
    /**
     * 医院名称
     */
    private String yymc;
    /**
     * 省
     */
    private String province;
    /**
     * 市
     */
    private String city;
    /**
     * 区
     */
    private String area;
    /**
     * 地址
     */
    private String address;
    /**
     * 经度
     */
    private String longitude;
    /**
     * 纬度
     */
    private String latitude;
    /**
     * 医院规模
     */
    private String yygm;

	/**
	 * 医院规模
	 */
	private String yyxz;
    /**
     * 联系总机
     */
    private String lxzj;
    /**
     * 公共邮箱
     */
    private String ggyx;
    /**
     * 院长姓名
     */
    private String yzxm;
    /**
     * 院长联系方式
     */
    private String yzlxfs;
    /**
     * 副院长姓名
     */
    private String fyzxm;
    /**
     * 副院长联系方式
     */
    private String fyzlxfs;
    /**
     * 医务处处长姓名
     */
    private String ywcczxm;
    /**
     * 医务处处长联系方式
     */
    private String ywcczlxfs;
    /**
     * 教务处处长姓名
     */
    private String jwcczxm;
    /**
     * 教务处处长联系方式
     */
    private String jwcczlxfs;
    /**
     * 药剂科主任姓名
     */
    private String yjkzrxm;
    /**
     * 药剂科主任联系方式
     */
    private String yjkzrlsfs;
    /**
     * 院病床总数（张）
     */
    private String ybczs;

	/**
	 * 医院官网
	 */
    private String website;

	/**
	 * 主流供货商业
	 */
	private String zlghsy;

    /**
     * 普什品种是否入院
     */
    private String pspzsfry;
    /**
     * 普什品种配送商业
     */
    private String pspzpssy;
    /**
     * 组织机构ID
     */
    private String deptId;
    /**
     * 是否删除
     */
	@TableLogic
    private String delFlag;
    /**
     * 是否禁用
     */
    private String enableFlag;
    /**
     * 所属租户
     */
    private Integer tenantId;
    /**
     * 创建时间
     */
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    private Integer createUser;
    /**
     * 更新时间
     */
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    private Integer updateUser;
    }
