package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import com.qunzhixinxi.hnqz.admin.enums.CategoryEnum;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.DecimalMin;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 积分包结算信息
 *
 * @author pigx code generator
 * @date 2021-01-26 15:44:49
 */
@Data
@TableName("wm_score_package_settle_note")
@EqualsAndHashCode(callSuper = true)
public class WmScorePackageSettleNote extends Model<WmScorePackageSettleNote> {

	private static final long serialVersionUID = -8023429988222929988L;

	/**
	 * id
	 */
	@TableId
	private Integer id;

	/**
	 * 积分包id
	 */
	private String packageId;

	/**
	 * 积分包名称
	 */
	@TableField(exist = false)
	private String packageName;

	/**
	 * 积分包状态id
	 */
	private String packageStatusId;

	/**
	 * 任务id
	 */
	private String taskId;

	/**
	 * 结算金额
	 */
	@DecimalMin("0")
	private BigDecimal settleAmount;

	/**
	 * 实际结算金额
	 */
	@DecimalMin("0")
	private BigDecimal actualAmount;

	/**
	 * 用户id
	 */
	private String userId;

	/**
	 * 发票类型
	 */
	private Integer invoiceType;

	/**
	 * 结算流水号
	 */
	private String settleNo;

	/**
	 * 折扣
	 */
	private BigDecimal discount;

	/**
	 * 结算信息状态
	 */
	private Integer settleNoteStatus;

	/**
	 * 发票类目
	 */
	private String categoryName;

	/**
	 * 备注
	 */
	private String remark;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 提交时间
	 */
	private LocalDateTime subTime;

	/**
	 * 提交到零工平台的时间
	 */
	private LocalDateTime subToGigTime;

	/**
	 * 回调时间
	 */
	private LocalDateTime notifyTime;

	/**
	 * 税邦云流水号
	 */
	private String streamId;

	/**
	 * 身份证号
	 */
	private String idCardNumber;

	/**
	 * 结算类型
	 */
	private String subType;

	/**
	 * 税源地
	 */
	private SubjectLocation subjectLocation;

	/**
	 * 第三方任务id
	 */
	private String thirdTaskId;

	/**
	 * 是否完成完单操作（1：已完单，0：未完单）
	 */
	private Integer finishTaskFlag;

	/**
	 * 实际结算企业id
	 */
	private Integer settleDeptId;

	/**
	 * 实际结算企业subId
	 */
	private Integer settleDeptSubId;

	/**
	 * 复核状态
	 */
	private UpmsState.SettleFinancialReviewStatus reviewStatus;

	/**
	 * 复核时间
	 */
	private LocalDateTime reviewTime;

	/**
	 * 复核人
	 */
	private Integer reviewUser;

	/**
	 * 真实名称
	 */
	@TableField(exist = false)
	private String realName;

	@TableField(exist = false)
	private String idStr;

	/**
	 * 提交时间-起始（用于范围查询）
	 */
	@TableField(exist = false)
	private LocalDateTime startSubTime;

	/**
	 * 提交时间-结束（用于范围查询）
	 */
	@TableField(exist = false)
	private LocalDateTime endSubTime;

	/**
	 * MAH结算-药企deptId
	 */
	@TableField(exist = false)
	private Integer mahSettleDeptId;

	public String toCategoryName() {

		if (CategoryEnum.CATEGORY_1.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_1.getDesc();
		} else if (CategoryEnum.CATEGORY_2.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_2.getDesc();
		} else if (CategoryEnum.CATEGORY_3.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_3.getDesc();
		} else if (CategoryEnum.CATEGORY_4.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_4.getDesc();
		}

		return "";
	}
}
