package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;
import java.util.List;

/**
 * 任务表
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
@Data
@TableName(value = "wm_task", autoResultMap = true)
@EqualsAndHashCode(callSuper = true)
public class WmTask extends Model<WmTask> {
    private static final long serialVersionUID = 1L;


    @TableId
    private String id;

    /**
     * 任务编号
     */
    private String taskNumber;

    /**
     * 任务类型ID
     */
    private String taskTypeId;

    /**
     * 任务类型名称
     */
    @TableField(exist = false)
    private String taskTypeName;

    Integer score;

    String scorePackageDrugId;

    String scorePackageLevel1Id;

    String scorePackageId;

    /**
     * 积分包名称
     */
    @TableField(exist = false)
    private String scorePackageName;

    String taskRuleId;

    /**
     * 调研时间
     */
    private LocalDateTime lookintoDate;
    /**
     * 省
     */
    private String province;
    /**
     * 市
     */
    private String city;
    /**
     * 区
     */
    private String area;
    /**
     * 地址
     */
    private String address;
    /**
     * 调研类型ID
     */
    private String lookintoTypeId;
    /**
     * 任务内容ID
     */
    private String taskContentId;
    /**
     * 任务状态
     */
    private String taskStatus;

    /**
     * 提交审核状态
     */
    private String submitStatus;

    /**
     * 任务用户ID
     */
    private String taskUserId;

    /**
     * 用户类型ID
     */
    private String taskUserType;

    /**
     * 服务药企
     */
    private String drugEntId;

    /**
     * 分享图片地址
     */
    private String shareImgUrl;

    /**
     * 组织机构ID
     */
    private String deptId;
    /**
     * 是否删除
     */
    private String delFlag;
    /**
     * 是否禁用
     */
    private String enableFlag;
    /**
     * 所属租户
     */
    private Integer tenantId;
    /**
     * 创建时间
     */
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    private Integer createUser;
    /**
     * 更新时间
     */
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    private String updateUser;

    private String platAuditStatus;

    @TableField(typeHandler = JacksonTypeHandler.class)
    private List<String> extIds;

    private String taskInfoImg;

    /**
     * 对比结果
     */
    private String compareResult;
    /**
     * 审批意见
     */
    private String approvalOpinion;
    /**
     * 审批说明
     */
    private String approvalInfo;

    private String realFlag;

    private Integer reportOneId;
    private String reportOneApprovalStatus;
    private String reportOneApprovalOpinion;
    private String reportOneApprovalInfo;

    private Integer reportSecondId;
    private String reportSecondApprovalStatus;
    private String reportSecondApprovalOpinion;
    private String reportSecondApprovalInfo;

    private Integer reportDrugId;
    private String reportDrugApprovalStatus;
    private String reportDrugApprovalOpinion;
    private String reportDrugApprovalInfo;

    /**
     * 接单对象list
     */
    @TableField(exist = false)
    private WmTaskContent wmTaskContent;

    @TableField(exist = false)
    private String type;

    /**
     * cso审批说明
     */
    private String taskStatusInfo;


    private String taskFrom;

    /**
     * 复审次数记录
     */
    private Integer reviewTaskCount;

    /**
     * 企业复审次数记录
     */
    private Integer deptReviewTaskCount;

    /**
     * 任务用户用户名
     */
    @TableField(exist = false)
    private String taskUsername;

    /**
     * 关联的用户手机号
     */
    @TableField(exist = false)
    private String username;

    /**
     * 结算状态
     */
    @TableField(exist = false)
    private Integer settleStatus;

    /**
     * 提交时间
     */
    @TableField(exist = false)
    private LocalDateTime subTime;

    /**
     * 提交到零工时间
     */
    @TableField(exist = false)
    private LocalDateTime subToGigTime;

    /**
     * 结算时间
     */
    @TableField(exist = false)
    private LocalDateTime notifyDate;

    /**
     * 请求ip
     */
    private String remoteIp;

    /**
     * ip归属地
     */
    private String ip2region;
}
