package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 任务积分规则
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:24
 */
@Data
@TableName("wm_task_rule")
@EqualsAndHashCode(callSuper = true)
public class WmTaskRule extends Model<WmTaskRule> {
	private static final long serialVersionUID = 1L;

	@TableId
	private String id;
	/**
	 * 药企ID
	 */
	private String drugentId;
	/**
	 * 规则类型，1药企 2一级代理商
	 */
	private String ruleTypeId;
	/**
	 * 规则月份
	 */
	private String ruleMonth;
	/**
	 * 一级代理商ID
	 */
	private String level1Id;
	/**
	 * 二级代理商ID
	 */
	private String level2Id;
	/**
	 * 组织机构ID
	 */
	private String deptId;
	/**
	 * 是否删除
	 */
	private String delFlag;
	/**
	 * 是否禁用
	 */
	private String enableFlag;
	/**
	 * 所属租户
	 */
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	private Integer createUser;
	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	private Integer updateUser;
}
