package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;
import java.util.Map;

/**
 * 用户签到详情实体
 *
 * @author lixuesong
 * @date 2022年01月18日 17:45
 */
@Data
@TableName(value = "wm_user_sign_detail", autoResultMap = true)
@EqualsAndHashCode(callSuper = true)
public class WmUserSignDetail extends Model<WmUserSignDetail> {
	private static final long serialVersionUID = 832214215288873739L;

	/**
	 * 主键id
	 */
	@TableId
	private Integer id;

	/**
	 * 签到表id
	 */
	private Integer signId;

	/**
	 * 推广药品
	 */
	private String[] drug;

	/**
	 * 拜访目的
	 */
	private String[] purpose;

	/**
	 * 拜访目的名称
	 */
	@TableField(exist = false)
	private String[] purposeName;

	/**
	 * 拜访结果
	 */
	private String result;

	/**
	 * 拜访结果名称
	 */
	@TableField(exist = false)
	private String resultName;

	/**
	 * 拜访科室(科室和图片数据冗余存入detail字段)
	 */
	private String[] department;

	/**
	 * 详情数据
	 */
	@TableField(typeHandler = FastjsonTypeHandler.class)
	private List<Map<String, Object>> detail;

	/**
	 * 所属模板类型(通过wm_dept_task_type_template表配置的)
	 */
	private UpmsType.TemplateType templateType;

	/**
	 * 拜访人员
	 */
	private String visitor;

	/**
	 * 备注
	 */
	private String remark;
}
