package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 文库-文章
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:24
 */
@Data
@TableName("wm_wk_article")
@EqualsAndHashCode(callSuper = true)
public class WmWkArticle extends Model<WmWkArticle> {
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	@TableId
	private Integer id;
	/**
	 * 文章标题
	 */
	private String title;

	private String description;
	/**
	 * 作者
	 */
	private String author;
	/**
	 * 封面
	 */
	private String fm;
	/**
	 * 文章内容
	 */
	private String content;
	/**
	 * 文章来源
	 */
	private String source;

	/**
	 * 转发数
	 */
	private Integer forwardNum;

	/**
	 * 阅读数
	 */
	private Integer readNum;

	/**
	 * 组织机构ID
	 */
	private Integer deptId;
	/**
	 * 是否删除
	 */
	@TableLogic
	private Integer delFlag;
	/**
	 * 是否禁用
	 */
	private Integer enableFlag;
	/**
	 * 所属租户
	 */
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	private Integer createUser;
	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	private Integer updateUser;


	private String score;

	private Integer newFlag;

	private Integer hotFlag;

	private String area;

	/**
	 * 文章来源(来源企业)
	 */
	private String[] sourceEnt;

}
