package com.qunzhixinxi.hnqz.admin.entity.vo;

import com.qunzhixinxi.hnqz.admin.api.constant.UpmsState;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 财务结算复核汇总VO
 *
 * @author lixuesong
 * @date 2024/01/08
 */
@Data
public class SettleFinancialReviewVO implements Serializable {
	private static final long serialVersionUID = -4383632697565147294L;

	/**
	 * 用户id
	 */
	private Integer userId;

	/**
	 * 企业id
	 */
	private Integer deptId;

	/**
	 * 用户姓名
	 */
	private String realname;

	/**
	 * 用户名
	 */
	private String username;

	/**
	 * 身份证号
	 */
	private String idCardNumber;

	/**
	 * 结算渠道
	 */
	private SubjectLocation subjectLocation;

	/**
	 * 结算金额
	 */
	private BigDecimal settleAmount;

	/**
	 * 实际结算金额
	 */
	private BigDecimal actualAmount;

	/**
	 * 积分包个数
	 */
	private Integer packageCount;

	/**
	 * 复核标记
	 */
	private Boolean reviewFlag;

	/**
	 * 结算表id
	 */
	private String[] settleNoteIds;
}
