package com.qunzhixinxi.hnqz.admin.entity.vo;

import com.baomidou.mybatisplus.annotation.TableId;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskContent;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 任务表
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
@Data
public class WmTaskVO implements Serializable {
	private static final long serialVersionUID = 1L;

	@TableId
	private String id;
	/**
	 * 任务类型ID
	 */
	private String taskTypeId;

	/**
	 * 任务类型名称
	 */
	private String taskTypeName;

	Integer score;

	String scorePackageDrugId;

	String scorePackageLevel1Id;

	String scorePackageId;

	String taskRuleId;

	/**
	 * 调研时间
	 */
	private LocalDateTime lookintoDate;
	/**
	 * 省
	 */
	private String province;
	/**
	 * 市
	 */
	private String city;
	/**
	 * 区
	 */
	private String area;
	/**
	 * 地址
	 */
	private String address;
	/**
	 * 调研类型ID
	 */
	private String lookintoTypeId;
	/**
	 * 任务内容ID
	 */
	private String taskContentId;
	/**
	 * 任务状态
	 */
	private String taskStatus;

	/**
	 * 提交审核状态
	 */
	private String submitStatus;

	/**
	 * 任务用户ID
	 */
	private String taskUserId;

	/**
	 * 用户类型ID
	 */
	private String taskUserType;

	/**
	 * 服务药企
	 */
	private String drugEntId;

	/**
	 * 分享图片地址
	 */
	private String shareImgUrl;

	/**
	 * 组织机构ID
	 */
	private String deptId;
	/**
	 * 是否删除
	 */
	private String delFlag;
	/**
	 * 是否禁用
	 */
	private String enableFlag;
	/**
	 * 所属租户
	 */
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	private Integer createUser;
	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	private String updateUser;

	private String platAuditStatus;

	private List<String> extIds;

	private String taskInfoImg;

	/**
	 * 对比结果
	 */
	private String compareResult;
	/**
	 * 审批意见
	 */
	private String approvalOpinion;

	/**
	 * 审批意见中文名称
	 */
	private String approvalOpinionName;

	/**
	 * 审批说明
	 */
	private String approvalInfo;

	private String realFlag;

	private Integer reportOneId;
	private String reportOneApprovalStatus;
	private String reportOneApprovalOpinion;
	private String reportOneApprovalInfo;

	private Integer reportSecondId;
	private String reportSecondApprovalStatus;
	private String reportSecondApprovalOpinion;
	private String reportSecondApprovalInfo;

	private Integer reportDrugId;
	private String reportDrugApprovalStatus;
	private String reportDrugApprovalOpinion;
	private String reportDrugApprovalInfo;

	/**
	 * 接单对象list
	 */
	private WmTaskContent wmTaskContent;

	private String type;

	/**
	 * cso审批说明
	 */
	private String taskStatusInfo;


	private String taskFrom;

	/**
	 * 任务用户用户名
	 */
	private String taskUsername;

	/**
	 * 关联的用户手机号
	 */
	private String username;

	/**
	 * 报告单号
	 */
	private String reportNo;

	/**
	 * 源头包积分包id
	 */
	private String scoreId;

	/**
	 * 分配对象类型（0-药企，1-一级CSO，2-二级CSO）
	 */
	private String typeid;

	/**
	 * 积分包名称
	 */
	private String scorePackageName;
}
