package com.qunzhixinxi.hnqz.admin.oe.controller;

import com.qunzhixinxi.hnqz.admin.oe.entity.vo.OeDictItemVO;
import com.qunzhixinxi.hnqz.common.core.util.R;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * 字典管理
 */
@Slf4j
@RestController
@RequestMapping("/oe/dict")
public class OeDictController {

    /**
     * 通过字典标记查找字典
     *
     * @param symbol 字典标记
     * @return 字典项
     */
    @GetMapping("/symbol/{symbol}")
    public R<List<OeDictItemVO>> getDictBySymbol(@PathVariable("symbol") String symbol) {
        List<OeDictItemVO> list = new ArrayList<>();
        switch (symbol) {
            case "tenant_level":
                OeDictItemVO itemVO = OeDictItemVO.builder().build();
                itemVO.setDictSymbol("tenant_level");
                itemVO.setLabel("药企");
                itemVO.setItemValue("ENT");
                list.add(itemVO);
                OeDictItemVO itemVO2 = OeDictItemVO.builder().build();
                itemVO2.setDictSymbol("tenant_level");
                itemVO2.setLabel("CSO");
                itemVO2.setItemValue("CSO");
                list.add(itemVO2);
                OeDictItemVO itemVO3 = OeDictItemVO.builder().build();
                itemVO3.setDictSymbol("tenant_level");
                itemVO3.setLabel("终端");
                itemVO3.setItemValue("TERMINAL");
                list.add(itemVO3);
                break;
            case "loc_flag":
                list.add(OeDictItemVO.builder().dictSymbol("loc_flag").label("启用").itemValue("OK").build());
                list.add(OeDictItemVO.builder().dictSymbol("loc_flag").label("停用").itemValue("LOC").build());
                break;
            case "del_flag":
                list.add(OeDictItemVO.builder().dictSymbol("del_flag").label("正常").itemValue("OK").build());
                list.add(OeDictItemVO.builder().dictSymbol("del_flag").label("删除").itemValue("DEL").build());
                break;
            case "permissions":
                list.add(OeDictItemVO.builder().dictSymbol("permissions").label("导出").itemValue("EXPORT").build());
                break;
            case "cso_type":
                list.add(OeDictItemVO.builder().dictSymbol("cso_type").label("团队").itemValue("CSO_TEAM").build());
                list.add(OeDictItemVO.builder().dictSymbol("cso_type").label("公司").itemValue("CSO_ENT").build());
                break;
            case "drug_type":
                list.add(OeDictItemVO.builder().dictSymbol("drug_type").label("原研").itemValue("RLD").build());
                list.add(OeDictItemVO.builder().dictSymbol("drug_type").label("仿制").itemValue("ANDA").build());
                break;
            default:
        }

        return R.ok(list);
    }
}
