package com.qunzhixinxi.hnqz.admin.oe.entity.dto;

import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * oe用户请求
 *
 * @author lixuesong
 * @date 2023/08/08
 */

public class OeUserRequest {

    /**
     * 保存参数
     *
     * @author lixuesong
     * @date 2023/08/08
     */

    @Data
    public static class ToSave implements Serializable {

        private static final long serialVersionUID = 8049239105004782547L;

        /**
         * 用户名
         */
        @NotBlank(message = "手机号必填")
        private String username;

        /**
         * 姓名
         */
        @NotBlank(message = "承接方必填")
        private String realName;

        /**
         * 身份证号
         */
        private String idCardNumber;

        /**
         * 角色id
         */
        @NotNull(message = "角色必填")
        private Long roleId;

        /**
         * 省
         */
        private String province;

        /**
         * 省编码
         */
        private String provinceCode;

        /**
         * 市
         */
        private String city;

        /**
         * 市编码
         */
        private String cityCode;

    }

    /**
     * 更新参数
     *
     * @author lixuesong
     * @date 2023/08/08
     */

    @Data
    public static class ToUpdate implements Serializable {

        private static final long serialVersionUID = 1588035989045460863L;

        /**
         * 主键id
         */
        @NotNull(message = "用户id必填")
        private Long userId;

        /**
         * 姓名
         */
        private String realName;

        /**
         * 身份证号
         */
        private String idCardNumber;

        /**
         * 角色id
         */
        @NotNull(message = "角色必填")
        private Long roleId;

        /**
         * 省
         */
        private String province;

        /**
         * 省编码
         */
        private String provinceCode;

        /**
         * 市
         */
        private String city;

        /**
         * 市编码
         */
        private String cityCode;

    }

    /**
     * 分页参数
     *
     * @author lixuesong
     * @date 2023/08/08
     */
    @Data
    public static class ToPage implements Serializable {

        private static final long serialVersionUID = -3670005114779918409L;

        /**
         * 承接方
         */
        private String realName;

        /**
         * 派工方
         */
        private String tenantName;

        /**
         * 手机号
         */
        private String phone;

        /**
         * 角色id
         */
        private Long roleId;

        /**
         * 启用状态
         */
        private String lockFlag;
    }
}
