package com.qunzhixinxi.hnqz.admin.service;

import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;

/**
 * 业务未读提醒服务层
 *
 * @author lixuesong
 * @date 2023/10/25
 */
public interface WmBizReminderService {

	/**
	 * 标记未读
	 *
	 * @param bizReminderType 提醒类型
	 * @param deptId 部门id
	 */
	void markUnread(UpmsType.BizReminderType bizReminderType, Integer deptId);

	/**
	 * 标记已读
	 *
	 * @param bizReminderType 提醒类型
	 * @param deptId 部门id
	 */
	void markRead(UpmsType.BizReminderType bizReminderType, Integer deptId);

	/**
	 * 获取标记状态
	 *
	 * @param bizReminderType 提醒类型
	 * @return {@link Boolean} 是否已读
	 */
	Boolean getReadStatus(UpmsType.BizReminderType bizReminderType);
}
