package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPlatformQuizTestResult;
import com.qunzhixinxi.hnqz.admin.api.model.WmQuizResultModel;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

import java.util.Collection;
import java.util.List;

/**
 * WmPlatformQuizTestResultService
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-10-25 15:44
 */
public interface WmPlatformQuizTestResultService extends IService<WmPlatformQuizTestResult> {

	/**
	 * 获取平台试卷结果
	 *
	 * @param userId  用户ID
	 * @param quizIds 试卷ID
	 * @return 答题结果
	 */
	List<WmPlatformQuizTestResult> listPltQuizResults(Integer userId, List<Integer> quizIds);

	/**
	 * 获取平台试卷结果
	 *
	 * @param userIds  用户ID
	 * @return 答题结果
	 */
	List<WmPlatformQuizTestResult> listPltQuizResults(Collection<Integer> userIds);

	/**
	 * 用户保存平台试卷测试结果
	 *
	 * @param quizResults 试卷结果
	 * @param user        用户信息
	 * @return 保存结果
	 */
	Boolean createQuizTestResult(WmQuizResultModel[] quizResults, HnqzUser user);
}
