package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmTaskDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSubmissionRule;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskContent;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.List;

/**
 * 任务内容表
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
public interface WmTaskContentService extends IService<WmTaskContent> {

	/**
	 * 提交任务
	 *
	 * @param wmTaskContent 任务内容
	 * @return 保存结果
	 */
	R<?> saveTaskContent(WmTaskContent wmTaskContent, String ip, String region);

	/**
	 * 获取任务类型校验规则
	 *
	 * @param taskTypeId 任务类型id
	 * @param deptId     企业id
	 * @return 任务类型
	 */
	List<WmTaskSubmissionRule.SubmissionRule> getTaskSubmissionRule(String taskTypeId, String deptId);

	/**
	 * 三方提交任务
	 *
	 * @param resource 任务信息
	 * @return 创建结果
	 */
	boolean saveTaskContent1(WmTaskDTO.OnOutPartyCreate resource);

	/**
	 * 校验积分上线
	 *
	 * @param userId  用户id
	 * @param deptId  部门id
	 * @param pkgType 积分包类型
	 */
	void limitScore(Integer userId, Integer deptId, String pkgType);
}
