package com.qunzhixinxi.hnqz.admin;

import com.deepoove.poi.XWPFTemplate;
import com.deepoove.poi.config.Configure;
import com.deepoove.poi.policy.HackLoopTableRenderPolicy;
import com.qunzhixinxi.hnqz.admin.entity.model.excel.SettlementProofModel;
import com.qunzhixinxi.hnqz.admin.util.OsEnvUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 导出测试
 *
 * @author lixuesong
 * @date 2023/12/01
 */
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest(classes = {HnqzAdminApplication.class})
public class ExportTest {

//	@Test
	public void testExport() throws Exception {
		// 服务器模板文件路径
		String resourcePath = "D:\\li312\\Desktop\\settlement_application_form_template.docx";

		HackLoopTableRenderPolicy policy = new HackLoopTableRenderPolicy();

		Configure config = Configure.newBuilder().bind("package_list", policy).build();

		List<SettlementProofModel.PackageDetail> packageList = new ArrayList<>();
		SettlementProofModel.PackageDetail packageDetail = new SettlementProofModel.PackageDetail();
		packageDetail.setNumber("666");
		packageDetail.setScorePackageName("这个积分包名称怎么样12345");
		packageDetail.setTaskUsername("迪丽热巴");
		packageDetail.setBankName("中国建设银行");
		packageDetail.setBankCardNumber("123456789123456789");
		packageDetail.setSubjectLocation("正启之星");
		packageDetail.setSettleAmount("100000.00");
		packageDetail.setActualAmount("100000.00");
		packageList.add(packageDetail);
		packageList.add(packageDetail);

		XWPFTemplate template = XWPFTemplate.compile(resourcePath, config).render(
				new HashMap<String, Object>() {{
					// 积分包列表
					put("package_list", packageList);
					// 实际到账金额
					put("total_settle_amount", "999999.99");
					// 实际结算金额
					put("total_settle_amount_cn", "九十九万九千九百九十九");
				}}
		);

		File file = new File("D:\\li312\\Desktop\\temp\\test.docx");
		FileOutputStream outputStream = new FileOutputStream(file);
		template.write(outputStream);

	}
}
