package com.qunzhixinxi.hnqz.admin;

import cn.hutool.core.codec.Base64;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.entity.SysUserExtRecord;
import com.qunzhixinxi.hnqz.admin.entity.SysUserSub;
import com.qunzhixinxi.hnqz.admin.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import com.qunzhixinxi.hnqz.admin.service.SysDeptService;
import com.qunzhixinxi.hnqz.admin.service.SysUserExtRecordService;
import com.qunzhixinxi.hnqz.admin.service.SysUserService;
import com.qunzhixinxi.hnqz.admin.service.SysUserSubService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.io.File;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 图片base64测试类
 *
 * @author lixuesong
 * @date 2023/10/27
 */
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest(classes = {HnqzAdminApplication.class})
public class ImgBase64Test {

	@Autowired
	private SysUserSubService sysUserSubService;

	@Autowired
	private SysUserExtRecordService sysUserExtRecordService;

	@Autowired
	private SysDeptService sysDeptService;

//	@Test
	public void base64ToImgtest() {
		List<SysUserSub> userSubList = sysUserSubService.list(Wrappers.<SysUserSub>lambdaQuery()
				.eq(SysUserSub::getCertStatus, 1)
				.eq(SysUserSub::getSubjectLocation, SubjectLocation.HUI_QI_YUN));

		Set<Integer> userIds = userSubList.stream().map(SysUserSub::getUserId).collect(Collectors.toSet());

		List<SysUserExtRecord> userExtRecordList = sysUserExtRecordService.list(Wrappers.<SysUserExtRecord>lambdaQuery()
				.in(SysUserExtRecord::getUserId, userIds)
				.eq(SysUserExtRecord::getDelFlag, DelEnum.NOT_DEL.val())
				.select(SysUserExtRecord::getIdCardFrontBase64, SysUserExtRecord::getIdCardBackBase64, SysUserExtRecord::getDeptId,
						SysUserExtRecord::getRealName, SysUserExtRecord::getIdCardNumber));

		userExtRecordList.forEach(sysUserExtRecord -> {

			SysDept sysDept = sysDeptService.getById(sysUserExtRecord.getDeptId());

			String parentFileName = String.format("D:\\li312\\Desktop\\huiqiyun_cert_user\\%s", sysDept.getName());
			File parentFile = new File(parentFileName);
			if (!parentFile.exists()) {
				parentFile.mkdirs();
			}

			String frontFileName = String.format("%s\\%s_%s_front.jpg",
					parentFileName, sysUserExtRecord.getRealName(), sysUserExtRecord.getIdCardNumber());
			System.out.println("frontFileName: " + frontFileName);
			File frontFile = new File(frontFileName);

			Base64.decodeToFile(sysUserExtRecord.getIdCardFrontBase64(), frontFile);

			String backFileName = String.format("%s\\%s_%s_back.jpg",
					parentFileName, sysUserExtRecord.getRealName(), sysUserExtRecord.getIdCardNumber());
			System.out.println("backFileName: " + backFileName);
			File backFile = new File(backFileName);

			Base64.decodeToFile(sysUserExtRecord.getIdCardBackBase64(), backFile);
		});
	}
}
