package com.qunzhixinxi.hnqz.admin;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.read.builder.ExcelReaderBuilder;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.qunzhixinxi.hnqz.admin.entity.WmDaPharmacy;
import com.qunzhixinxi.hnqz.admin.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.service.WmDaPharmacyService;
import com.qunzhixinxi.hnqz.admin.util.MapUtil;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

/**
 * 手动导入调查信息测试
 *
 * @author lixuesong
 * @date 2023/09/27
 */
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest(classes = {HnqzAdminApplication.class})
public class ManualImportSurveyInfoTest {

    @Autowired
    private WmDaPharmacyService wmDaPharmacyService;

//    @Test
    public void testImport() {
        ExcelReaderBuilder readerBuilder = EasyExcel.read("D:\\li312\\Desktop\\零售终端门店资料1027.xlsx");
        List<Object> objects = readerBuilder.doReadAllSync();
        System.out.println(objects);

		List<WmDaPharmacy> pharmacyList = new ArrayList<>();
        for (int i = 1; i < objects.size(); i++) {

//            try {
//                Thread.sleep(200);
//            } catch (InterruptedException e) {
//                throw new RuntimeException(e);
//            }

            LinkedHashMap<Integer, String> map = (LinkedHashMap) objects.get(i);
            String name = map.get(2);
            String address = map.get(4);

			int count = wmDaPharmacyService.count(Wrappers.<WmDaPharmacy>lambdaQuery()
					.eq(WmDaPharmacy::getPharmacyName, name)
					.eq(WmDaPharmacy::getDelFlag, DelEnum.NOT_DEL.val()));
			if (count > 0) {
				System.out.println(name + " 已存在,自动跳过");
			}

			WmDaPharmacy wmDaPharmacy = new WmDaPharmacy();
            wmDaPharmacy.setPharmacyName(name);
            wmDaPharmacy.setAddress(address);
            wmDaPharmacy.setProvince("");
            wmDaPharmacy.setCity("");
            wmDaPharmacy.setArea("");
            //更新审核信息
            LocalDateTime now = LocalDateTime.now();
            wmDaPharmacy.setCreateTime(now);
            wmDaPharmacy.setCreateUser(-1);
            // 根据地址转换经纬度
            this.convertToLatAndLong(wmDaPharmacy);

            System.out.println(String.format("第%s条,%s-%s-%s", i, name, address, wmDaPharmacy));

			pharmacyList.add(wmDaPharmacy);
        }
		wmDaPharmacyService.saveBatch(pharmacyList);


    }

    /**
     * 根据地址转换经纬度
     *
     * @param wmDaPharmacy
     */
    private void convertToLatAndLong(WmDaPharmacy wmDaPharmacy) {
        String fullAddress = wmDaPharmacy.getProvince() + wmDaPharmacy.getCity() + wmDaPharmacy.getArea()
                + wmDaPharmacy.getAddress();
        JSONObject jsonObject = MapUtil.getLatAndLogByName(fullAddress);
        if (jsonObject != null) {
            wmDaPharmacy.setProvince(jsonObject.getString("province"));
            wmDaPharmacy.setCity(jsonObject.getString("city"));
            wmDaPharmacy.setArea(jsonObject.getString("district"));
            String location = jsonObject.getString("location");
            if (null != location && location.split(",").length > 0) {
                wmDaPharmacy.setLongitude(location.split(",")[0]);
                wmDaPharmacy.setLatitude(location.split(",")[1]);
            }
        }
    }
}
