package com.qunzhixinxi.hnqz.daemon.quartz.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.daemon.quartz.entity.WmScorePackageStatus;
import com.qunzhixinxi.hnqz.daemon.quartz.service.WmScorePackageStatusService;
import org.springframework.security.access.prepost.PreAuthorize;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;


/**
 * 积分包状态
 *
 * @author pigx code generator
 * @date 2020-07-31 20:07:00
 */
@RestController
@AllArgsConstructor
@RequestMapping("/wmscorepackagestatus" )
public class WmScorePackageStatusController {

    private final  WmScorePackageStatusService wmScorePackageStatusService;

    /**
     * 分页查询
     * @param page 分页对象
     * @param wmScorePackageStatus 积分包状态
     * @return
     */
    @GetMapping("/page" )
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackagestatus_view')" )
    public R getWmScorePackageStatusPage(Page page, WmScorePackageStatus wmScorePackageStatus) {
        return R.ok(wmScorePackageStatusService.page(page, Wrappers.query(wmScorePackageStatus)));
    }


    /**
     * 通过id查询积分包状态
     * @param id id
     * @return R
     */
    @GetMapping("/{id}" )
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackagestatus_view')" )
    public R getById(@PathVariable("id" ) Integer id) {
        return R.ok(wmScorePackageStatusService.getById(id));
    }

    /**
     * 新增积分包状态
     * @param wmScorePackageStatus 积分包状态
     * @return R
     */
    @SysLog("新增积分包状态" )
    @PostMapping
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackagestatus_add')" )
    public R save(@RequestBody WmScorePackageStatus wmScorePackageStatus) {
        return R.ok(wmScorePackageStatusService.save(wmScorePackageStatus));
    }

    /**
     * 修改积分包状态
     * @param wmScorePackageStatus 积分包状态
     * @return R
     */
    @SysLog("修改积分包状态" )
    @PutMapping
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackagestatus_edit')" )
    public R updateById(@RequestBody WmScorePackageStatus wmScorePackageStatus) {
        return R.ok(wmScorePackageStatusService.updateById(wmScorePackageStatus));
    }

    /**
     * 通过id删除积分包状态
     * @param id id
     * @return R
     */
    @SysLog("通过id删除积分包状态" )
    @DeleteMapping("/{id}" )
    @PreAuthorize("@pms.hasPermission('quartz_wmscorepackagestatus_del')" )
    public R removeById(@PathVariable Integer id) {
        return R.ok(wmScorePackageStatusService.removeById(id));
    }

}
