package com.qunzhixinxi.hnqz.daemon.quartz.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.daemon.quartz.enums.CategoryEnum;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.DecimalMin;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 结算表
 *
 * @author pigx code generator
 * @date 2021-01-26 15:44:49
 */
@Data
@TableName("wm_score_package_settle_note")
@EqualsAndHashCode(callSuper = true)
public class WmScorePackageSettleNote extends Model<WmScorePackageSettleNote> {
	private static final long serialVersionUID = 1L;


	@TableId
	private Integer id;

	private String packageId;

	private String packageStatusId;

	private String taskId;

	@DecimalMin("0")
	private BigDecimal settleAmount;

	private String userId;


	private Integer invoiceType;

	private String settleNo;

	private BigDecimal discount;

	private Integer settleNoteStatus;

	private String categoryName;

	private String remark;

	private LocalDateTime createTime;

	private LocalDateTime updateTime;

	private LocalDateTime subTime;

	private LocalDateTime notifyTime;

	private String streamId;

	private String idCardNumber;

	private String subType;

	@TableField(exist = false)
	private String realName;

	@TableField(exist = false)
	private String idStr;


	public String toCategoryName() {

		if (CategoryEnum.CATEGORY_1.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_1.getDesc();
		} else if (CategoryEnum.CATEGORY_2.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_2.getDesc();
		} else if (CategoryEnum.CATEGORY_3.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_3.getDesc();
		} else if (CategoryEnum.CATEGORY_4.getCode().equals(invoiceType)) {
			return CategoryEnum.CATEGORY_4.getDesc();
		}

		return "";
	}
}
